import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;
/**
 *           
 * InfoMatrix<T>
 * 
 * @author dafna minster & sarah funk
 * @version 11/06/2011
 * @param <T>
 */
public class ListMat<T>
{
	private List<InfoMatrix<T>> lst;
	private int row;
	private int col;
	
	/**
	 *   
	 *     - 
	 * @param row
	 * @param column
	 */
	public ListMat(int row , int col)
	{
		this.lst =new List<InfoMatrix<T>>();
		this.row = row ;
		this.col = col ;
		
	}
	
	/**
	 *       
	 * @return
	 */
	public int getNumRows()
	{
		return this.row ;
	}
	
	/**
	 *       
	 * @return
	 */
	public int getNumCols()
	{
		return this.col ;
	}
	
	/**
	 *        
	 *    
	 *       ,      
	 *  :     
	 * @param row
	 * @param column
	 * @param value
	 */
	public void setMatrixItem (int row , int column , T value)
	{
		boolean found = false ;
		Node<InfoMatrix<T>> pos = lst.getFirst();
		for(;pos!=null && !found ;pos=pos.getNext())
		{
			if(pos.getInfo().getRow()==row &&pos.getInfo().getCol()==column)
			{
				pos.getInfo().setInfoT(value);
				found = true ;
			}
		}

		if(!found)
		{
			this.lst.insert(null, new InfoMatrix<T>(row,column , value)) ;
		}
		
	}
	
	/**
	 *        
	 *     
	 * @param row
	 * @param column
	 * @return
	 */
	public T getMatrixItem (int row , int column)
	{
		Node<InfoMatrix<T>> pos = lst.getFirst();
		for(;pos!=null  ;pos=pos.getNext())
		{
			if(pos.getInfo().getRow()==row &&pos.getInfo().getCol()==column)
			{
				return pos.getInfo().getInfoT();
				
			}
		}
		return null ;
	}
	
	/**
	 *       
	 * @param row
	 */
	public void printRow(int row)
	{
		for(int c = 0 ; c< this.col ;c++)
		{
			Node<InfoMatrix<T>> pos = lst.getFirst();
			for(;pos!=null  ;pos=pos.getNext())
			{
				if(pos.getInfo().getRow()==row && pos.getInfo().getCol()==c)
					System.out.print(pos.getInfo().getInfoT()+ " ");
			}
		}
	}
	
	/**
	 *       
	 * @param col
	 */
	public void printCol(int col)
	{
		for(int r = 0 ; r< this.row ;r++)
		{
			Node<InfoMatrix<T>> pos = lst.getFirst();
			for(;pos!=null  ;pos=pos.getNext())
			{
				if(pos.getInfo().getRow()==r && pos.getInfo().getCol()==col)
					System.out.println(pos.getInfo().getInfoT()+ " ");
			}
		}
		
	}
	
	/**
	 *       
	 * @return
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		if(this.lst.isEmpty())
			return "[]";
		String str ="";
		
		for(int r= 0 ; r<this.row; r++)
		{
			for(int c = 0 ; c<this.col ; c++)
			{
				boolean isNull=true ;
				Node<InfoMatrix<T>> pos = this.lst.getFirst();
				for(;pos!=null  ;pos=pos.getNext())
				{
					if(pos.getInfo().getRow()==r && pos.getInfo().getCol()==c)
					{
						str+= pos.getInfo().getInfoT().toString()+ " ";
						isNull = false ;
					}
				}
				if(isNull)
					str+= "  null  ";
			}
			str+= "\n" ;	
		}
		
		return str ;
	}
}
