/**
 *   -        
 * @author dafna minster & sarah funk
 * @version 11/06/2011
 * @param <T>
 */
public class MatrixT<T>
{
	private T[][] tMatrix;
	/**
	 *   
	 *     - 
	 * @param row
	 * @param column
	 */
	
	public MatrixT(int row , int column )
	{
		this.tMatrix = (T[][])new Object[row][column]; 
	}
	
	/**
	 *       
	 * @return
	 */
	public int getNumRows()
	{
		return this.tMatrix.length ;
	}
	
	/**
	 *       
	 * @return
	 */
	public int getNumCols()
	{
		return this.tMatrix[0].length ;
	}
	
	/**
	 *        
	 *    
	 * :    
	 * @param row
	 * @param column
	 * @param value
	 */
	public void setMatrixItem (int row , int column , T value)
	{
		this.tMatrix[row][column] = value;
	}
	
	/**
	 *        
	 *     
	 * @param row
	 * @param column
	 * @return
	 */
	public T getMatrixItem (int row , int col)
	{
		return this.tMatrix[row][col];
	}
	
	/**
	 *       
	 * @param row
	 */
	public void printRow(int row)
	{
		for(int col=0 ; col<this.tMatrix[row].length;col++)
		{
			System.out.print(this.tMatrix[row][col]+" ");
		}
	}
	
	/**
	 *       
	 * @param col
	 */
	public void printCol(int col)
	{
		for(int row =0 ; row<this.tMatrix.length;row++)
		{
			System.out.println(this.tMatrix[row][col]+" ");
		}
	}
	
	
	/**
	 *       
	 * @return
	 * @see java.lang.Object#toString()
	 */
	
	public String toString ()
	{
		int cellLength = 10; 
		String str = "     ";
		for (Integer j=0 ; j<this.tMatrix[0].length ; j++)
			str += ( new PrintfFormat("%"+cellLength+"s  ").sprintf(j.toString()) + "   ");
		
		for (int i=0 ; i<this.tMatrix.length ; i++)
		{
			str += ("\n   ");
			for (Integer j=0 ; j<this.tMatrix[i].length ; j++)
			{	str += ("  ");
				for (int k = 0 ; k < cellLength + 2 ; k++ )
					str += ("-");
				str += (" ");
			}
			str += ("\n "+i+" | ");
			for (int j=0 ; j<this.tMatrix[i].length ; j++)
			{
				if (this.tMatrix[i][j]!= null)
				     str += (new PrintfFormat(" %"+cellLength+"s ").sprintf(this.tMatrix[i][j].toString()) + " | ");
				else 
					str+= (new PrintfFormat(" %"+cellLength+"s ").sprintf("null ") + " | ");
			}
		}
		str += ("\n   ");
		for (Integer j=0 ; j<this.tMatrix[this.tMatrix.length-1].length ; j++)
		{	str += ("  ");
			for (int k = 0 ; k < cellLength + 2 ; k++ )
				str += ("-");
			str += (" ");
		}
		
		return str+="\n\n";
	}	
	
	
}
