import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;
/**
 *       
 * @author dafna minster & sarah funk
 * @version 11/06/2011
 * @param <T>
 * @param <E>
 */
public class ListOfListT<T,E>
{
	private List<ListT<T>> list;

	/**
	 *     
	 *
	 */
	public ListOfListT()
	{
		this.list = new List<ListT<T>>();		
	}
	
	/**
	 *       
	 * @return
	 */
	public Node<ListT<T>> getFirst()
	{
		return(this.list.getFirst());
	}
	
	/**
	 *         
	 * @param p
	 * @return
	 */
	public Node<T> getInfoOutsideList(Node<ListT<T>> p)
	{
		return(p.getInfo().getList().getFirst());
	}
	
	/**
	 *     
	 * @param p
	 * @return
	 */
	public List<T> getInsideList(Node<ListT<T>> p)
	{
		return(p.getInfo().getList());
	}
	
	
	/**
	 *      -   
	 * @param i
	 * @param j
	 * @param x
	 */
	public void insert(int i , int j , E x)
	{
		InfoMatrix<E> info = new InfoMatrix<E>(i,j,x);
		
		Node<ListT<T>> pOut=this.list.getFirst();		//  
		while ((pOut!=null)&&(pOut.getInfo().getI()!=i))
			pOut = pOut.getNext();
		
		if (pOut == null)						//  
		{
			ListT<T> l = new ListT<T>(i);
			l.insert((T)info);
			this.list.insert(null, l);
		}
		else
			pOut.getInfo().insert( (T) info);
	}
	
	/**
	 *         -  
	 * @param i
	 * @param j
	 * @param x
	 */
	public void insertSorted(int i , int j , E x)
	{
		InfoMatrix<E> info = new InfoMatrix<E>(i,j,x);
		
		Node<ListT<T>> pOut=this.list.getFirst();			//  
		while ((pOut!=null)&&(pOut.getInfo().getI()!=i))
			pOut = pOut.getNext();
		
		if (pOut == null)		//  i :    
		{
			ListT<T> l = new ListT<T>(i);
			l.insert( (T) info);
			Node<ListT<T>> p=this.list.getFirst();			//  
			Node<ListT<T>> q=null;
			while ((p!=null)&&(p.getInfo().getI()< i))
			{
				q = p;
				p = p.getNext();
			}
			this.list.insert(q, l);
		}
		else					//  i :   	
		{
			Node<InfoMatrix<E>> p = (Node<InfoMatrix<E>>) pOut.getInfo().getList().getFirst();
			Node<InfoMatrix<E>> q = null;
			
			while ((p!=null) && (p.getInfo().getRow()< j))
			{
				q = p;
				p = p.getNext();
			}
			pOut.getInfo().getList().insert((Node<T>) q, (T)info);
		}
	}
	
	/**
	 *               
	 *   
	 *  :              
	 *       
	 * @param matrix
	 * @param withOut
	 * @return
	 */
	public ListOfListT<T,E> turnOverMatrixToArrayOfLists1 (E[][] matrix , E withOut)
	{
		ListOfListT<T,E> lList = new ListOfListT<T,E>();
		for (int i=0 ; i<matrix.length ; i++)
			for (int j=0 ; j<matrix[i].length ; j++)
				if (!(matrix[i][j].toString().equals(withOut.toString())))
					lList.insertSorted(i,j,matrix[i][j]);
		return (lList); 
	}
	
	/**
	 *     , 
	 * @param i
	 * @param j
	 */
	public void delete (int i , int j)
	{
		Node<ListT<T>> pOut=this.list.getFirst();		//  
		while ((pOut!=null)&&(pOut.getInfo().getI()!=i))
			pOut = pOut.getNext();
		
		if (pOut != null)								//  
		{
			Node<InfoMatrix<E>> pIn = (Node<InfoMatrix<E>>) pOut.getInfo().getList().getFirst();
			
			while ((pIn!=null) && (pIn.getInfo().getRow() != j))
				pIn = pIn.getNext();

			if (pIn!=null)  pOut.getInfo().getList().remove((Node<T>)pIn);
		}
	}
	
	/**
	 *      
	 * @return
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		String s = "\n     L i s t   of    L i s t s \n"; 
			   s +="     ************************* \n";
			   s +="\n      |"+"\n      |"+"\n      V";
		Node<ListT<T>> temp = this.list.getFirst();
		while (temp != null)
		{
			s += (temp.getInfo().toString() + "\n      |"+"\n      V");
			temp = temp.getNext();
		}
		s += ("\n     ---\n     ---\n");
		return s;
		}
	
}
