import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;
/**
 *       
 * @author dafna minster & sarah funk
 * @version 11/06/2011
 * @param <T>
 * @param <E>
 */
public class ArrayOfListT<T,E>
{
	private List<T>[] array;
	
	/**
	 *   .   
	 * @param n
	 */
	public ArrayOfListT(int n)
	{
		this.array = new List[n];
		for(int i=0; i<this.array.length ; i++)
			this.array[i] = new List<T>();	
	}
	
	
	/**
	 *     
	 * @return
	 */
	public int getArrayLength()
	{
		return (this.array.length);
	}
	
	/**
	 *         
	 * @param i
	 * @return
	 */
	public Node<T> getFirst(int i)
	{
		return (this.array[i].getFirst());
	}
	
	/**
	 *         
	 *    
	 * @param i
	 * @return
	 */
	public List<T> getListCopy(int i)
	{
		List<T> lst = new List<T>();		//   
		Node<T> q = lst.getFirst();
		Node<T> p = this.array[i].getFirst();
		
		while (p != null)
		{
			q = lst.insert(q, p.getInfo());
			p = p.getNext();
		}
		return (lst);
	}
	
	
	/**
	 *       
	 * InfoMatrix
	 * @param i
	 * @param j
	 * @param x
	 * @return
	 */
	public Node<T> insert(int i , int j , E x)
	{
		InfoMatrix<E> info = new InfoMatrix<E>(i,j,x);
		return (this.array[i].insert(null, (T) info));		
	}
	
	/**
	 *               
	 * @param i
	 * @param j
	 * @param x
	 * @return
	 */
	public Node<T> insertSorted(int i , int j , E x)
	{
		InfoMatrix<E> info = new InfoMatrix<E>(i,j,x);
			
		if ( this.array[i] == null )				//    
			return this.array[i].insert(null, (T)info);
		else
		{											//     
			Node<InfoMatrix<E>> p = (Node<InfoMatrix<E>>) this.array[i].getFirst();
			Node<InfoMatrix<E>> q = null;
			
			while ((p!=null) && (p.getInfo().getRow()< j))
			{
				q = p;
				p = p.getNext();
			}
			return this.array[i].insert((Node<T>) q, (T)info);
		}
	}
	
	
	/**
	 *   -        
	 * @param i
	 * @param j
	 * @return
	 */
	public Node<T> delete (int i , int j)
	{
		Node<InfoMatrix<E>> p = (Node<InfoMatrix<E>>) this.array[i].getFirst();
			
		while ((p!=null) && (p.getInfo().getCol() != j))
			p = p.getNext();

		if (p!=null)  return this.array[i].remove((Node<T>)p);
		
		return null;
	}
	
	
	
	/**
	 *     
	 * @param x
	 *  
	 * @param place
	 * @return
	 */
	public Node<T> deleteXfromList (E x, int place)
	{
		Node<InfoMatrix<E>> p;

		p = (Node<InfoMatrix<E>>) this.array[place].getFirst();		
		while (p!=null) 
		{
			if ((p.getInfo().getInfoT().toString().equals(x.toString())))
			{
				return (this.array[place].remove((Node<T>)p));
			}
			else
				p = p.getNext();
		}
		return null;
	}
	
	/**
	 *        
	 *            
	 *   
	 * @param matrix
	 * @param withOut
	 * @return
	 */	
	
	public ArrayOfListT<T,E> turnOverMatrixToArrayOfLists (E[][] matrix , E withOut)
	{
		ArrayOfListT<T,E> aList = new ArrayOfListT<T,E>(matrix.length);
		for (int i=0 ; i<matrix.length ; i++)
			for (int j=0 ; j<matrix[i].length ; j++)
				if (!(matrix[i][j].toString().equals(withOut.toString())))
					aList.insertSorted(i,j,matrix[i][j]);
		return (aList); 
	}
	
	/**
	 *       
	 * @return
	 * @see java.lang.Object#toString()
	 */
	public String toString ()
	{
		int cellLength = 3;
		String s = "\n         A r r a y    of     L i s t s \n";
		s +=      ("         ***************************** \n");
		for (Integer i=0 ; i<this.array.length ; i++)
		{
			s += ("\n  ----- ");
			s += ("\n | "+ new PrintfFormat("%"+cellLength+"s ").sprintf(i.toString()) +"| --> ");
			Node<T> temp = this.array[i].getFirst();
			while (temp != null)
			{
				s += (temp.getInfo().toString() + "--> ");
				temp = temp.getNext();
			}
			s += ("|| ");
		}
		s += ("\n  ----- \n");
		
		return s;
	}	
	
	
	

	//	       
	public boolean isNumber (E className)
	{
		return ((className.getClass().toString().equals("class java.lang.Double")) || 
				(className.getClass().toString().equals("class java.lang.Float")) || 
				(className.getClass().toString().equals("class java.lang.Long"))  || 
			    (className.getClass().toString().equals("class java.lang.Short")) || 
				(className.getClass().toString().equals("class java.lang.Integer")));
	}
	
	
	/**
	 *              
	 *            , , 
	 * @param i
	 * @param j
	 * @param x
	 * @return
	 */
	public Node<T> insertSortedByInfo(int i , int j , E x)
	{
		InfoMatrix<E> info = new InfoMatrix<E>(i,j,x);
			
		if ( this.array[i] == null )				//    
			return this.array[i].insert(null, (T)info);
		else
		{											//     
			Node<InfoMatrix<E>> p = (Node<InfoMatrix<E>>) this.array[i].getFirst();
			Node<InfoMatrix<E>> q = null;
			
			if (isNumber(x))
			{
				while ((p!=null) && 
					   ((Double.valueOf(p.getInfo().getInfoT().toString()).doubleValue() < 
							   (Double.valueOf(x.toString()).doubleValue()))))
				{
					q = p;
					p = p.getNext();
				}
				return this.array[i].insert((Node<T>) q, (T)info);
			}
			else
			{
				while ((p!=null) && (p.getInfo().getInfoT().toString().compareTo(x.toString()) < 0))
				{
					q = p;
					p = p.getNext();
				}
				return this.array[i].insert((Node<T>) q, (T)info);
			}
		}
	}
	
	
	
	
}
